<script lang="ts">
export default {
    data(): any {
        return {
            devis: [],
            detailDevis: [],
            products: [],
            clients: [],
            loading: true
        }
    },
    async mounted() {
        this.getProducts();
        this.getClients();
        await this.getDevis();
        this.getDetailDevis();
    },
    methods: {
        async getDevis() {
            const response = await fetch('http://localhost:8000/api/deviss', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseData = await response.json();
            this.devis = responseData['hydra:member'];
        },
        async getDetailDevis() {
            const response = await fetch('http://localhost:8000/api/detail_deviss', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseData = await response.json();
            let detailDevis = responseData['hydra:member'];
            let i = 1;
            for (const detail of detailDevis) {
                let devis = this.devis.find((devis: any) => devis['@id'] === detail.devis);
                let client = this.clients.find((client: any) => client['@id'] === devis.client);
                devis.client = client;
                if (devis.statut === 'En attente') {
                    devis.statuscolor = 'primary';
                } else if (devis.statut === 'Accepté') {
                    devis.statuscolor = 'success';
                } else {
                    devis.statuscolor = 'error';
                }
                let montant = 0;
                for (let i=0; i<detail.product.length; i++) {
                    let product = this.products.find((product: any) => product['@id'] === detail.product[i]);
                    detail.product[i] = product;
                    montant += product.prix;
                }
                devis.budget = montant;
                devis.detail = detail;
                this.detailDevis.push(devis);
                i++;
                if (i > detailDevis.length) {
                    this.loading = false;
                }
            }
        },
        async getClients() {
            const response = await fetch('http://localhost:8000/api/clients', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseData = await response.json();
            this.clients = responseData['hydra:member'];
        },
        async getProducts() {
            const response = await fetch('http://localhost:8000/api/produits', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseData = await response.json();
            this.products = responseData['hydra:member'];
        },
    }
};
</script>

<template>
    <v-card elevation="10" class="">
        <v-card-item class="py-2 px-4">
            <v-card-title class="text-h5 pt-sm-2 pb-7">Derniers devis</v-card-title>
            <v-table class="month-table">
                <thead>
                    <tr>
                        <th class="text-subtitle-1 font-weight-bold">Id</th>
                        <th class="text-subtitle-1 font-weight-bold">Client</th>
                        <th class="text-subtitle-1 font-weight-bold">Date création</th>
                        <th class="text-subtitle-1 font-weight-bold">Statut</th>
                        <th class="text-subtitle-1 font-weight-bold text-right">Montant</th>
                        <th class="text-subtitle-1 font-weight-bold text-right"></th>
                    </tr>
                </thead>
                <tbody v-if="!loading">
                    <tr v-for="item in detailDevis" :key="item.id" class="month-item">
                        <td>
                            <p class="text-15 font-weight-medium">{{ item.id }}</p>
                        </td>
                        <td>
                            <div class="">
                                <h6 class="text-subtitle-1 font-weight-bold">{{ item.client.nom }}</h6>
                            </div>
                        </td>
                        <td>
                            <h6 class="text-body-1 text-muted">{{ item.date_creation }}</h6>
                        </td>
                        <td>
                            <v-chip  :class="'text-body-1 bg-' + item.statuscolor " color="white"  size="small" >{{
                                item.statut
                            }}</v-chip>
                        </td>
                        <td>
                            <h6 class="text-h6 text-right">{{ item.budget }}</h6>
                        </td>
                    </tr>
                </tbody>
            </v-table>
            <div class="container-loader">
                <div v-if="loading" class="loader"></div>
            </div>
        </v-card-item>
    </v-card>
</template>

<style scoped>
    .container-loader{
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;
    }
    .loader {
        position: relative;
        width: 50px;
        height: 50px;
        border: 3px solid rgb(255,111,0);
        border-radius: 50%;
        border-top-color: transparent;
        animation: spin 1s linear infinite;
        margin: auto auto;
    }
    @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
    }
</style>